--^=====================================^--
--)-----[ AW's SAMANID EMPIRE MOD ]-----(--
--V=====================================V--
-->-----------> UA FUNCTIONS <----------<--

-------------------------------------------
------------[ CITY CONNECTIONS ]-----------
-------------------------------------------

GameEvents.PlayerDoTurn.Add(
function(playerID)
	local pPlayer = Players[playerID]
	if (pPlayer:IsAlive()) then
		if (pPlayer:GetCivilizationType() == GameInfoTypes.CIVILIZATION_AW_SAMANID) then
			for pCity in pPlayer:Cities() do
				local science = GameInfoTypes.YIELD_SCIENCE
				-- I don't why this line is here, to be honest.
				-- Give capital-connected cities 2 science if w/out player-founded religion and 3 if with it
				if not (pCity:IsCapital()) then
					if (pPlayer:IsCapitalConnectedToCity(pCity)) then
						if (pCity:GetReligiousMajority() == pPlayer:GetCapitalCity():GetReligiousMajority()) then
							pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_AW_SAMANID_DUMMY_SCIENCE_LOW, 0)
							pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_AW_SAMANID_DUMMY_SCIENCE_HIGH, 1)
						else
							pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_AW_SAMANID_DUMMY_SCIENCE_LOW, 1)
							pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_AW_SAMANID_DUMMY_SCIENCE_HIGH, 0)
						end
					else
						return
					end
				else
					pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_AW_SAMANID_DUMMY_SCIENCE_HIGH, 0)
					pCity:SetNumRealBuilding(GameInfoTypes.BUILDING_AW_SAMANID_DUMMY_SCIENCE_LOW, 0)
				end
			end
		end
	end
end)

-------------------------------------------
------------[ CULTURE PER TECH ]-----------
-------------------------------------------

function AW_Samanid_UACulture(playerID)
	local pPlayer = Players[playerID]
	if (pPlayer:IsAlive()) then
--		print('pPlayer identified.')
		if (pPlayer:GetCivilizationType() == GameInfoTypes.CIVILIZATION_AW_SAMANID) then
--			print('Valid civ type. Getting number of techs...')
			--local num_Techs = TeamTechs[Teams[pPlayer:GetTeam()]:GetTeamTechs()]:GetNumTechsKnown()
			local num_Techs = Teams[pPlayer:GetTeam()]:GetTeamTechs():GetNumTechsKnown()
--			print('Number of techs: '..num_Techs)
			pPlayer:ChangeJONSCulture(num_Techs)
		end
	end
end
GameEvents.PlayerDoTurn.Add(AW_Samanid_UACulture)