--^=====================================^--
--)-----[ AW's SAMANID EMPIRE MOD ]-----(--
--V=====================================V--
-->-----------> UU FUNCTIONS <----------<--

print("Loaded - Samanid UU Functions")

-------------------------------------------
---------[ GOLD FROM BEING KILLED ]--------
-------------------------------------------

GameEvents.UnitPrekill.Add(
function(iOwner, iUnit, _, _, _, bDelay, iKiller)
print("GameEvents.UnitPrekill("..tostring(iOwner)..", "..tostring(iUnit)..", _, _, _, "..tostring(bDelay)..", "..tostring(iKiller)..")")
	local pPlayer = Players[iOwner]
	local pUnit = pPlayer:GetUnitByID(iUnit)
	if not (pUnit:GetUnitType() == GameInfoTypes.UNIT_AW_GHILMAN) then return end
	print("		* Since 'tis a Ghilman killed, let\'s give out some gold...?")
	if ( (bDelay == true) and (iKiller ~= iOwner) and (iKiller > -1) ) then -- first fire, if killed by someone else
		iExperience = pUnit:GetExperience()
		print("			* Adding "..tostring(iExperience).." Gold")
		pPlayer:ChangeGold(iExperience)
	end
end)

-------------------------------------------
--------[ NEARBY GHILMAN PROMOTION ]-------
-------------------------------------------

GameEvents.UnitSetXY.Add(
function(iPlayer, iUnit, iUnitX, iUnitY)
	local pPlayer = Players[iPlayer]
	local pUnit = pPlayer:GetUnitByID(iUnit)
	if (pPlayer:IsAlive()) then
		if (pUnit:GetUnitType() == GameInfoTypes.UNIT_AW_GHILMAN) then
			pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_GHILMAN_ADJ, false)
			for mUnit in pPlayer:Units() do
				if mUnit ~= pUnit then
					if (mUnit:GetUnitType() == GameInfoTypes.UNIT_AW_GHILMAN) then
						if Map.PlotDistance(iUnitX, iUnitY, mUnit:GetX(), mUnit:GetY()) == 1 then
							pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_GHILMAN_ADJ, true)
						else
							pUnit:SetHasPromotion(GameInfoTypes.PROMOTION_GHILMAN_ADJ, false)
						end
					end
				end
			end
		end
	end
end)

-------------------------------------------
-----------[ NEAR ENEMY CAPITAL ]----------
-------------------------------------------

local iUUType = GameInfoTypes.UNIT_AW_GHILMAN
local iPromotionType = GameInfoTypes.PROMOTION_GHILMAN_NEARCAP

local iMaxCivs = GameDefines.MAX_MAJOR_CIVS
local iMaxPlayers = GameDefines.MAX_PLAYERS

--print('Variables predefined. Commence function:')
GameEvents.UnitSetXY.Add(
function(iPlayer, iUnit, iUnitX, iUnitY)
	if iPlayer <  iMaxCivs then
		local pPlayer = Players[iPlayer]
--		print('pPlayer identified')
		local pUnit = pPlayer:GetUnitByID(iUnit)
		if pUnit:GetUnitType() == iUUType then
--			print('Unit is valid.')
			for i = 0, iMaxPlayers - 1, 1 do
				local pEnemyPlayer = Players[i]
				if Teams[pPlayer:GetTeam()]:IsAtWar(pEnemyPlayer:GetTeam()) and not pEnemyPlayer:IsBarbarian() then
--					print('Hold up! Let\'s check our variables...')
--					print('My unit\'s X:'..iUnitX..', and my unit\'s Y:'..iUnitY)
--					print( "Enemy capital X: ".. pEnemyPlayer:GetCapitalCity():GetX() ..", Y: ".. pEnemyPlayer:GetCapitalCity():GetY() )
--					print( "Distance to enemy capital: ".. Map.PlotDistance(iUnitX, iUnitY, pEnemyPlayer:GetCapitalCity():GetX(), pEnemyPlayer:GetCapitalCity():GetY()) )
--					print('Well, so nothing\'s wrong yet, let\'s move ahead...')

--					print('Checking distance...')
					if (Map.PlotDistance(iUnitX, iUnitY, pEnemyPlayer:GetCapitalCity():GetX(), pEnemyPlayer:GetCapitalCity():GetY()) <= 2) then
--						print('Result: Return true')
						pUnit:SetHasPromotion(iPromotionType, true)
					else
--						print('Result: Return false')
						pUnit:SetHasPromotion(iPromotionType, false)
					end
				end
			end
		end
	end
end)