--^=====================================^--
--)-----[ AW's SAMANID EMPIRE MOD ]-----(--
--V=====================================V--
-->---> CIV IV TRAITS COMPATIBILITY <---<--

CREATE TABLE IF NOT EXISTS 
	Leader_SharedTraits (
	LeaderType	text	REFERENCES	Leaders(Type)	default		null,
	TraitOne	text	REFERENCES	Policies(Type)	default		null,
	TraitTwo	text	REFERENCES	Policies(Type)	default		null);

INSERT OR REPLACE INTO Leader_SharedTraits
	(LeaderType,			TraitOne,				TraitTwo)
VALUES 
	('LEADER_AW_ISMAIL', 'POLICY_INVENTIVE_X', 'POLICY_MERCANTILE_X');

UPDATE Leaders 
SET Description = (CASE WHEN EXISTS(SELECT Type FROM Policies WHERE Type = 'POLICY_PHILOSOPHICAL_X' )
	THEN 'Ismail [ICON_RESEARCH][ICON_TRADE]'
	ELSE 'TXT_KEY_LEADER_AW_ISMAIL' END) 
WHERE Type = 'LEADER_AW_ISMAIL';

CREATE TRIGGER CivIVTraits_AW_Ismail
AFTER INSERT ON Leaders WHEN 'LEADER_AW_ISMAIL' = NEW.Type
BEGIN
	UPDATE Leaders 
	SET Description = (CASE WHEN EXISTS(SELECT Type FROM Policies WHERE Type = 'POLICY_PHILOSOPHICAL_X' )
		THEN 'Ismail [ICON_RESEARCH][ICON_TRADE]'
		ELSE 'TXT_KEY_LEADER_AW_ISMAIL' END) 
	WHERE Type = 'LEADER_AW_ISMAIL';
END;

 