--^=====================================^--
--)-----[ AW's SAMANID EMPIRE MOD ]-----(--
--V=====================================V--
-->---> CIV V TRAITS BGP ++ COMP 8) <---<--
--[[
	So basically, if my hunch is correct,
	Just make sure all Lua functions with
	actionable values that are within the Lua
	file are removed and re-added with those
	values x10.

	What I mean by "actionable value" is,
	well, like, the UA has culture directly
	infused each turn via Lua, so we redo that
	function. But the UA science modifier is
	controlled by a building, so that will
	be changed with SQL.

	Y'know what I mean?

	Let's get testing!
]]--

function AW_Samanid_CivVBGP_RemoveOldFunctions()
	local JFD_CivVBGP_ModID = "7bf1b4b5-bf19-44c2-abfa-69a7c72ed94e"
	local isUsingCivVBGP = false
	for _, mod in pairs(Modding.GetActivatedMods()) do
		if (mod.ID == JFD_CivVBGP_ModID) then
			isUsingCivVBGP = true
			-- || UA || --
			GameEvents.PlayerDoTurn.Remove(AW_Samanid_UACulture)
			GameEvents.PlayerDoTurn.Add(AW_Samanid_UACulturex10)
			--[[ 
			|| UU ||
			GameEvents.CanSaveUnit.Remove(AW_Samanid_UUCanSave)
			GameEvents.CanSaveUnit.Add(AW_Samanid_UUCanSavex10)
			GameEvents.UnitKilledInCombat.Remove(AW_Samanid_UUKilledInCombat)
			GameEvents.UnitKilledInCombat.Add(AW_Samanid_UUKilledInCombatx10)
			]]--
		end
		break
	end
end
Events.AfterModsActivate.Add(AW_Samanid_CivVBGP_RemoveOldFunctions)

function AW_Samanid_UACulturex10(playerID)
	local pPlayer = Players[playerID]
	if (pPlayer:IsAlive()) then
		print('pPlayer identified.')
		if (pPlayer:GetCivilizationType() == GameInfoTypes.CIVILIZATION_AW_SAMANID) then
			print('Valid civ type. Getting number of techs...')
			--local num_Techs = TeamTechs[Teams[pPlayer:GetTeam()]:GetTeamTechs()]:GetNumTechsKnown()
			local num_Techs = Teams[pPlayer:GetTeam()]:GetTeamTechs():GetNumTechsKnown()
			print('Number of techs: '..num_Techs)
			pPlayer:ChangeJONSCulture(num_Techs * 10)
		end
	end
end
--[[
function AW_Samanid_UUCanSavex10(iPlayer, iUnitID)
	-- This function is actually identical to the non-x10 version, but we need,
	-- essentially, to import iExperience into this file.
	local pPlayer = Players[iPlayer]
	local pUnit = pPlayer:GetUnitByID(iUnitID)
	if (pUnit:GetUnitType() == GameInfoTypes.UNIT_AW_GHILMAN) then
		iExperience = pUnit:GetExperience()
	end
end

function AW_Samanid_UUKilledInCombatx10(mPlayer, iPlayer, iUnitType)
	local pPlayer = Players[iPlayer]
	if (iUnitType == GameInfoTypes.UNIT_AW_GHILMAN) then
	-- the following line is the sole reason that the above function was replaced:
		iPlayer:ChangeGold(iExperience * 10)
	end
end
]]--


